#!/usr/local/bin/perl -w

my $version="0.1 (beta)";

#  Copyright (C) 1999 Axel Beckert <abe@deuxchevaux.org>
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#  You can reach the author by snail-mail at the following address:
#  
#  Axel Beckert
#  Saarbrcker Strae 267a
#  D-66125 Saarbrcken, Germany

# Scrambles HTML-Files by replacing each character by its entity.
# Blows files up by approximately factor 4. Use gzip or bzip2 to
# compress files back to normale size... :-)
#
# Parameter -a scrambles also space characters like blank, tab and
# newline.

# Example:
#
# * Before:
# <HTML><HEAD><TITLE>Test</TITLE></HEAD><BODY>
# This is a test!
# </BODY></HTML>
#
# * After:
# <HTML><HEAD><TITLE>&#084;&#101;&#115;&#116;</TITLE></HEAD><BODY>
# &#084;&#104;&#105;&#115; &#105;&#115; &#097; &#116;&#101;&#115;&#116;&#033;
# </BODY></HTML>

my $text="";
my $all=0;

if((0<scalar@ARGV)&&($ARGV[0]=~/^-/)){$all=1;shift@ARGV;}

while(<>){$text.=$_;}

$text=~s/&amp;/&/g;
$text=~s/&gt;/&#062;/g;
$text=~s/&lt;/&#060;/g;

$text=~s/&auml;//g;
$text=~s/&Auml;//g;
$text=~s/&ouml;//g;
$text=~s/&Ouml;//g;
$text=~s/&uuml;//g;
$text=~s/&Uuml;//g;
$text=~s/&szlig;//g;

$text=~s/&agrave;//g;
$text=~s/&Agrave;//g;
$text=~s/&aacute;//g;
$text=~s/&Aacute;//g;
$text=~s/&acirc;//g;
$text=~s/&Acirc;//g;
$text=~s/&atilde;//g;
$text=~s/&Atilde;//g;
$text=~s/&aring;//g;
$text=~s/&Aring;//g;
$text=~s/&aelig;//g;
$text=~s/&AElig;//g;

$text=~s/&egrave;//g;
$text=~s/&Egrave;//g;
$text=~s/&eacute;//g;
$text=~s/&Eacute;//g;
$text=~s/&Ecirc;//g;
$text=~s/&ecirc;//g;
$text=~s/&euml;//g;
$text=~s/&Euml;//g;

$text=~s/&igrave;//g;
$text=~s/&Igrave;//g;
$text=~s/&iacute;//g;
$text=~s/&Iacute;//g;
$text=~s/&icirc;//g;
$text=~s/&Icirc;//g;
$text=~s/&iuml;//g;
$text=~s/&Iuml;//g;

$text=~s/&ograve;//g;
$text=~s/&Ograve;//g;
$text=~s/&oacute;//g;
$text=~s/&Oacute;//g;
$text=~s/&ocirc;//g;
$text=~s/&Ocirc;//g;
$text=~s/&otilde;//g;
$text=~s/&Otilde;//g;
$text=~s/&oslash;//g;
$text=~s/&Oslash;//g;

$text=~s/&Ugrave;//g;
$text=~s/&ugrave;//g;
$text=~s/&Uacute;//g;
$text=~s/&uacute;//g;
$text=~s/&Ucirc;//g;
$text=~s/&ucirc;//g;

$text=~s/&Ntilde;//g;
$text=~s/&ntilde;//g;

$text=~s/&Ccedil;//g;
$text=~s/&ccedil;//g;

$text=~s/&yacute;//g;
$text=~s/&yuml;//g;

$text=~s/&ETH;//g;
$text=~s/&eth;//g;
$text=~s/&THORN;//g;
$text=~s/&thorn;//g;

$text=~s/&plusmn;//g;
$text=~s/&middot;//g;
$text=~s/&shy;//g;
$text=~s/&times;//g;
$text=~s/&divide;//g;
$text=~s/&brvbar;//g;
$text=~s/&not;//g;

$text=~s/&iexcl;//g;
$text=~s/&iquest;//g;

$text=~s/&cent;//g;
$text=~s/&pound;//g;
$text=~s/&curren;//g;
$text=~s/&yen;//g;

$text=~s/&sup1;//g;
$text=~s/&sup2;//g;
$text=~s/&sup3;//g;
$text=~s/&frac14;//g;
$text=~s/&frac12;//g;
$text=~s/&frac34;//g;

$text=~s/&acute;//g;
$text=~s/&cedil;//g;
$text=~s/&uml;//g;
$text=~s/&macr;//g;
$text=~s/&deg;//g;
$text=~s/&ordm;//g;
$text=~s/&ordf;//g;

$text=~s/&para;//g;
$text=~s/&sect;//g;
$text=~s/&micro;//g;

$text=~s/&copy;//g;
$text=~s/&reg;//g;

$text=~s/&raquo;//g;
$text=~s/&laquo;//g;

$text=~s/([>;])(([^<>&;]|[^&]{3,7};|&[^;]{3,7})+)([&<])/$1.
    join('',map{if((!m!\s!) || $all){$_=sprintf("&#%03d;",ord$_);}
		else{ $_; }}split('',$2)).$4/gem;

$text=~s/(<[^<>]+=\")([^\"]+)(\"[^<>]*>)/$1.
    join('',map{$_=sprintf("&#%03d;",ord$_);}split('',$2)).$3/ges;

print $text;
